Index: branches/std/src/lib/util/executor/executor.h
===================================================================
--- branches/std/src/lib/util/executor/executor.h	(revision 7211)
+++ branches/std/src/lib/util/executor/executor.h	(revision 7212)
@@ -192,5 +192,5 @@
 #define ExecutorExecute1(t1) \
    else if (this->paramCount == 1 && this->defaultValue[0] == t1##_PARAM) \
-    EXECUTOREXECUTER(_1_##t1)(t1##_FUNC(sub.getString(0), t1##_DEFGRAB(0)))
+    EXECUTOREXECUTER(_1_##t1)(t1##_FUNC((const char*)parameters, t1##_DEFGRAB(0)))
 
 //! execute-macro for functions with two parameters
@@ -270,5 +270,8 @@
     virtual void execute (BaseObject* object, const void* parameters = NULL)
     {
-      SubString sub((const char*)parameters, " \n\t", '\\');
+      SubString sub;
+      printf("===%s\n", (const char*)parameters);
+      if (parameters != NULL)
+        sub.split((const char*)parameters, " \n\t,", '\\');
 //! FUNCTOR_LIST is the List of Executive Functions
 #define FUNCTOR_LIST(x) ExecutorExecute ## x
@@ -332,5 +335,7 @@
     virtual void execute (BaseObject* object, const void* parameters = NULL)
     {
-      SubString sub(((const char*)parameters), " \n\t,");
+      SubString sub;
+      if (parameters != NULL)
+        sub.split((const char*)parameters, " \n\t,", '\\');
 //! FUNCTOR_LIST is the List of Executive Functions
 #define FUNCTOR_LIST(x) ExecutorExecute ## x
Index: branches/std/src/lib/util/loading/load_param.cc
===================================================================
--- branches/std/src/lib/util/loading/load_param.cc	(revision 7211)
+++ branches/std/src/lib/util/loading/load_param.cc	(revision 7212)
@@ -66,5 +66,5 @@
           ((this->executor->getType() & Executor_NoLoadString) == Executor_NoLoadString)))
     {
-      PRINTF(4)("Loading '%s' with Parameters '%s' onto: '%s'(%s)\n", this->paramName, loadString.c_str(), this->object->getName(), this->object->getClassName());
+      PRINTF(0)("Loading '%s' with Parameters '%s' onto: '%s'(%s)\n", this->paramName.c_str(), loadString.c_str(), this->object->getName(), this->object->getClassName());
       this->executor->execute(this->object, (const void*)loadString.c_str());
     }
Index: branches/std/src/lib/util/substring.cc
===================================================================
--- branches/std/src/lib/util/substring.cc	(revision 7211)
+++ branches/std/src/lib/util/substring.cc	(revision 7212)
@@ -14,4 +14,14 @@
 
    2005-06-10: some naming conventions
+
+//
+//  splitLine
+//  STL string tokenizer
+//
+//  Created by Clemens Wacha.
+//  Version 1.0
+//  Copyright (c) 2005 Clemens Wacha. All rights reserved.
+//
+
 */
 
@@ -35,5 +45,4 @@
                        string, split);
 }
-
 
 /**
@@ -48,9 +57,44 @@
                       string);
 }
-
 SubString::SubString(const std::string& string, const std::string& splitters, char escapeChar,char safemode_char, char comment_char)
 {
   SubString::splitLine(this->strings, this->offsets,
                        string, splitters, escapeChar, safemode_char);
+}
+
+
+unsigned int SubString::split(const std::string& string, char splitter)
+{
+  this->offsets.clear();
+  this->strings.clear();
+  char split[2];
+  split[0] = splitter;
+  split[1] = '\0';
+  SubString::splitLine(this->strings, this->offsets, string, split);
+  return strings.size();
+}
+
+
+/**
+ * Splits a String into a Substring removing all whiteSpaces
+ * @param string the String to Split
+ * @param whiteSpaces MUST BE __TRUE__
+ *
+ */
+unsigned int SubString::split(const std::string& string, bool whiteSpaces)
+{
+  this->offsets.clear();
+  this->strings.clear();
+  SubString::splitLine(this->strings, this->offsets, string);
+  return strings.size();
+}
+
+unsigned int SubString::split(const std::string& string, const std::string& splitters, char escapeChar,char safemode_char, char comment_char)
+{
+  this->offsets.clear();
+  this->strings.clear();
+  SubString::splitLine(this->strings, this->offsets,
+                       string, splitters, escapeChar, safemode_char);
+  return strings.size();
 }
 
Index: branches/std/src/lib/util/substring.h
===================================================================
--- branches/std/src/lib/util/substring.h	(revision 7211)
+++ branches/std/src/lib/util/substring.h	(revision 7212)
@@ -22,13 +22,13 @@
 {
  public:
-  SubString(const std::string& string, char splitter = ',');
+  SubString(const std::string& string = "", char splitter = ',');
   SubString(const std::string& string, bool whiteSpaces);
   SubString(const std::string& string, const std::string& splitters, char escapeChar ='\\', char safemode_char = '"', char comment_char = '\0');
   ~SubString();
 
-  SPLIT_LINE_STATE splitLine(std::vector<std::string>& ret,std::vector<unsigned int>& offsets,
-                             const std::string& line, const std::string& delimiters = " \t\r\n",
-                             char escape_char = '\\', char safemode_char = '"', char comment_char = '\0',
-                             SPLIT_LINE_STATE start_state = SL_NORMAL);
+  unsigned int split(const std::string& string = "", char splitter = ',');
+  unsigned int split(const std::string& string, bool whiteSpaces);
+  unsigned int split(const std::string& string, const std::string& splitters, char escapeChar ='\\', char safemode_char = '"', char comment_char = '\0');
+
 
   const std::string& operator[](unsigned int i) { return this->getString(i); };
@@ -37,4 +37,9 @@
   const std::string& getString(unsigned int i) { return this->strings[i]; };
   unsigned int getOffset(unsigned int i);
+
+  static SPLIT_LINE_STATE splitLine(std::vector<std::string>& ret,std::vector<unsigned int>& offsets,
+                                    const std::string& line, const std::string& delimiters = " \t\r\n",
+                                    char escape_char = '\\', char safemode_char = '"', char comment_char = '\0',
+                                    SPLIT_LINE_STATE start_state = SL_NORMAL);
 
   void debug() const;