Index: branches/std/src/util/Makefile.am
===================================================================
--- branches/std/src/util/Makefile.am	(revision 7211)
+++ branches/std/src/util/Makefile.am	(revision 7216)
@@ -15,6 +15,7 @@
 			animation/animation_player.cc \
 			\
-			track/pilot_node.cc \
-			track/track_manager.cc \
+			track/pilot_node.cc
+
+#			track/track_manager.cc \
 			track/track_node.cc
 
@@ -31,5 +32,6 @@
 			animation/t_animation.h \
 			\
-			track/pilot_node.h \
-			track/track_manager.h \
+			track/pilot_node.h
+
+#			track/track_manager.h \
 			track/track_node.h
Index: branches/std/src/util/fast_factory.cc
===================================================================
--- branches/std/src/util/fast_factory.cc	(revision 7211)
+++ branches/std/src/util/fast_factory.cc	(revision 7216)
@@ -29,5 +29,5 @@
  * @return a new FastFactory
  */
-FastFactory::FastFactory (ClassID classID, const char* fastFactoryName)
+FastFactory::FastFactory (ClassID classID, const std::string& fastFactoryName)
 {
   this->setClassID(CL_FAST_FACTORY, "FastFactory");
@@ -119,5 +119,5 @@
  * @returns true if found, false otherwise.
  */
-FastFactory* FastFactory::searchFastFactory(const char* fastFactoryName)
+FastFactory* FastFactory::searchFastFactory(const std::string& fastFactoryName)
 {
   if (FastFactory::first == NULL)
@@ -128,5 +128,5 @@
     while (tmpFac != NULL)
     {
-      if (strcmp(tmpFac->getName(), fastFactoryName))
+      if (fastFactoryName == tmpFac->getName())
         return tmpFac;
       tmpFac = tmpFac->next;
Index: branches/std/src/util/fast_factory.h
===================================================================
--- branches/std/src/util/fast_factory.h	(revision 7211)
+++ branches/std/src/util/fast_factory.h	(revision 7216)
@@ -80,10 +80,10 @@
 
     static FastFactory* searchFastFactory(ClassID classID);
-    static FastFactory* searchFastFactory(const char* fastFactoryName);
+    static FastFactory* searchFastFactory(const std::string& fastFactoryName);
 
     ClassID getStoredID() const { return this->storedClassID; };
 
   protected:
-    FastFactory (ClassID classID, const char* fastFactoryName = NULL);
+    FastFactory (ClassID classID, const std::string& fastFactoryName = "");
 
     /** sets the Next factory in the list @param nextFactory the next factory */
Index: branches/std/src/util/multiplayer_team_deathmatch.cc
===================================================================
--- branches/std/src/util/multiplayer_team_deathmatch.cc	(revision 7211)
+++ branches/std/src/util/multiplayer_team_deathmatch.cc	(revision 7216)
@@ -92,5 +92,5 @@
 
 
-void MultiplayerTeamDeathmatch::setDeathScreen(const char* imageName)
+void MultiplayerTeamDeathmatch::setDeathScreen(const std::string& imageName)
 {
   if( this->deathScreen)
Index: branches/std/src/util/multiplayer_team_deathmatch.h
===================================================================
--- branches/std/src/util/multiplayer_team_deathmatch.h	(revision 7211)
+++ branches/std/src/util/multiplayer_team_deathmatch.h	(revision 7216)
@@ -38,5 +38,5 @@
     inline void setDeathPenaltyTimeout(float time) { this->deathTimeout = time; }
     inline void setMaxKills(int kills) { this->maxKills = kills; }
-    void setDeathScreen(const char* imageName);
+    void setDeathScreen(const std::string& imageName);
 
   protected:
Index: branches/std/src/util/object_manager.cc
===================================================================
--- branches/std/src/util/object_manager.cc	(revision 7211)
+++ branches/std/src/util/object_manager.cc	(revision 7216)
@@ -97,5 +97,5 @@
  * this function also does a transformation from omList as char* to OM_LIST.
  */
-void ObjectManager::toList (WorldEntity* entity, const char* omList)
+void ObjectManager::toList (WorldEntity* entity, const std::string& omList)
 {
   this->toList(entity, ObjectManager::StringToOMList(omList));
@@ -153,10 +153,10 @@
  * @param level: level 0: only show list info; level 1: also show entities and their names.
  */
-void ObjectManager::debug(const char* listName, unsigned int level)
+void ObjectManager::debug(const std::string& listName, unsigned int level)
 {
   PRINT(0)("=================================\n");
   PRINT(0)("=ObjectManager-DEBUG=============\n");
   PRINT(0)("=================================\n");
-  if (listName == NULL || listName[0] == '\0')
+  if (listName.empty())
     for (unsigned int i = 0; i < OM_SIZE; ++i)
       debug((OM_LIST) i, level);
@@ -189,10 +189,10 @@
  * @returns the OM_LIST transformed from listName. or the default, if not found or NULL.
  */
-OM_LIST ObjectManager::StringToOMList(const char* listName)
-{
-  if (unlikely(listName == NULL)) return OM_DEFAULT_LIST;
+OM_LIST ObjectManager::StringToOMList(const std::string& listName)
+{
+  if (unlikely(listName.empty())) return OM_DEFAULT_LIST;
 
   for(unsigned int i = 0; i < OM_SIZE; ++i) {
-    if(!strcmp(listName, ObjectManager::objectManagerListNames[i])) {
+    if(listName == ObjectManager::objectManagerListNames[i]) {
       return (OM_LIST)i;
     }
Index: branches/std/src/util/object_manager.h
===================================================================
--- branches/std/src/util/object_manager.h	(revision 7211)
+++ branches/std/src/util/object_manager.h	(revision 7216)
@@ -76,5 +76,5 @@
 
   void toList (WorldEntity* entity, OM_LIST omList = OM_DEFAULT_LIST);
-  void toList (WorldEntity* entity, const char* omList);
+  void toList (WorldEntity* entity, const std::string& omList);
 
 
@@ -85,7 +85,7 @@
 
   void debug(OM_LIST omList, unsigned int level = 0) const;
-  void debug(const char* listName = NULL, unsigned int level = 0);
+  void debug(const std::string& listName = "", unsigned int level = 0);
 
-  static OM_LIST StringToOMList(const char* listName);
+  static OM_LIST StringToOMList(const std::string& listName);
   static const char* OMListToString(OM_LIST omList);
 
Index: branches/std/src/util/track/track_manager.h
===================================================================
--- branches/std/src/util/track/track_manager.h	(revision 7211)
+++ branches/std/src/util/track/track_manager.h	(revision 7216)
@@ -142,5 +142,5 @@
   // Methods to change the Path (initialisation)
   void workOn(unsigned int trackID);
-  void workOnS(const char* trackName);
+  void workOnS(const std::string& trackName);
 
   /** \see setCurveType(CurveType curveType, TrackElement* trackElem); @param curveType the type of the Curve */
@@ -157,5 +157,5 @@
   void fork(unsigned int count, ...);
   void forkS(unsigned int count, ...);
-  void forkS(const char* forkString);
+  void forkS(const std::string& forkString);
   void forkV(unsigned int count, int* trackIDs, char** trackNames, TrackElement* trackElem = NULL);
   void condition(unsigned int trackID, CONDITION cond, void* subject);