Index: branches/std/src/lib/graphics/effects/lense_flare.cc
===================================================================
--- branches/std/src/lib/graphics/effects/lense_flare.cc	(revision 7216)
+++ branches/std/src/lib/graphics/effects/lense_flare.cc	(revision 7218)
@@ -131,5 +131,5 @@
  * @param mode the mode character
  */
-GLint LenseFlare::charToFogMode(const char* mode)
+GLint LenseFlare::stringToFogMode(const std::string& mode)
 {}
 
Index: branches/std/src/lib/graphics/effects/lense_flare.h
===================================================================
--- branches/std/src/lib/graphics/effects/lense_flare.h	(revision 7216)
+++ branches/std/src/lib/graphics/effects/lense_flare.h	(revision 7218)
@@ -43,5 +43,5 @@
 
   private:
-    GLint charToFogMode(const char* mode);
+    GLint stringToFogMode(const std::string& mode);
     void setSourceVisibility(bool visibility) ;
 
Index: branches/std/src/lib/graphics/importer/static_model.cc
===================================================================
--- branches/std/src/lib/graphics/importer/static_model.cc	(revision 7216)
+++ branches/std/src/lib/graphics/importer/static_model.cc	(revision 7218)
@@ -499,4 +499,6 @@
  * String is different from the argument addFace,
  * in this, that the first Vertex/Normal/Texcoord is 1 instead of 0
+ *
+ * @TODO make it std::string conform
  */
 bool StaticModel::addFace (const std::string& faceStringInput)
Index: branches/std/src/lib/graphics/importer/texture_sequence.cc
===================================================================
--- branches/std/src/lib/graphics/importer/texture_sequence.cc	(revision 7216)
+++ branches/std/src/lib/graphics/importer/texture_sequence.cc	(revision 7218)
@@ -124,10 +124,7 @@
  * @returns true on success
  */
-bool TextureSequence::addFrame(const char* imageName)
+bool TextureSequence::addFrame(const std::string& imageName)
 {
-  if (imageName == NULL)
-    return false;
-
-  SDL_Surface* addSurface = IMG_Load(imageName);
+  SDL_Surface* addSurface = IMG_Load(imageName.c_str());
   bool success = this->addFrame(addSurface);
   delete addSurface;
Index: branches/std/src/lib/graphics/importer/texture_sequence.h
===================================================================
--- branches/std/src/lib/graphics/importer/texture_sequence.h	(revision 7216)
+++ branches/std/src/lib/graphics/importer/texture_sequence.h	(revision 7218)
@@ -23,5 +23,5 @@
     bool loadImageSeries(unsigned int count, ...);
     bool loadImageSeries(unsigned int count, va_list textureNames);
-    bool addFrame(const char* image);
+    bool addFrame(const std::string& image);
     bool addFrame(SDL_Surface* surface);
     bool addFrame(GLuint texture);
Index: branches/std/src/lib/gui/gl_gui/glgui_button.cc
===================================================================
--- branches/std/src/lib/gui/gl_gui/glgui_button.cc	(revision 7216)
+++ branches/std/src/lib/gui/gl_gui/glgui_button.cc	(revision 7218)
@@ -54,5 +54,5 @@
 }
 
-void GLGuiButton::setLabel(const char* label)
+void GLGuiButton::setLabel(const std::string& label)
 {
   this->label->setText(label);
Index: branches/std/src/lib/gui/gl_gui/glgui_button.h
===================================================================
--- branches/std/src/lib/gui/gl_gui/glgui_button.h	(revision 7216)
+++ branches/std/src/lib/gui/gl_gui/glgui_button.h	(revision 7218)
@@ -35,5 +35,5 @@
 
    void init();
-   void setLabel(const char* label);
+   void setLabel(const std::string& label);
 
    virtual void draw() const;
Index: branches/std/src/lib/gui/gl_gui/glgui_menu.h
===================================================================
--- branches/std/src/lib/gui/gl_gui/glgui_menu.h	(revision 7216)
+++ branches/std/src/lib/gui/gl_gui/glgui_menu.h	(revision 7218)
@@ -24,8 +24,8 @@
   void init();
 
-  void addItem(const char* itemName);
-  void removeItem(const char* itemName);
+  void addItem(const std::string& itemName);
+  void removeItem(const std::string& itemName);
   void removeItem(unsigned int itemNumber);
-  void selectItem(const char* itemName);
+  void selectItem(const std::string& itemName);
   void selectItem(unsigned int itemNumber);
 
Index: branches/std/src/lib/gui/gl_gui/glgui_widget.h
===================================================================
--- branches/std/src/lib/gui/gl_gui/glgui_widget.h	(revision 7216)
+++ branches/std/src/lib/gui/gl_gui/glgui_widget.h	(revision 7218)
@@ -47,5 +47,5 @@
     virtual char* save() {};
     /** loads options of the Widget. @param loadString a string containing the Options */
-    virtual void load(const char* loadString) {};
+    virtual void load(const std::string& loadString) {};
 
     void show();
Index: branches/std/src/lib/lang/base_object.cc
===================================================================
--- branches/std/src/lib/lang/base_object.cc	(revision 7216)
+++ branches/std/src/lib/lang/base_object.cc	(revision 7218)
@@ -34,6 +34,6 @@
 BaseObject::BaseObject()
 {
+  this->classID = CL_BASE_OBJECT;
   this->className = "BaseObject";
-  this->classID = CL_BASE_OBJECT;
 
   this->objectName = "";
@@ -78,5 +78,5 @@
  * @param className the class name
 */
-void BaseObject::setClassID(ClassID classID, const char* className)
+void BaseObject::setClassID(ClassID classID, const std::string& className)
 {
   //printf("%s(0x%.8X)->%s(0x%.8X)\n", this->className, this->classID, className, classID);
@@ -150,5 +150,5 @@
  * @returns true if it is, false otherwise
  */
-bool BaseObject::isA (const char* className) const
+bool BaseObject::isA (const std::string& className) const
 {
   ClassID classID = ClassList::StringToID(className);
@@ -163,7 +163,7 @@
  * @returns true on match, false otherwise.
  */
-bool BaseObject::operator==(const char* objectName)
-{
-  return (objectName != NULL && this->objectName == objectName);
+bool BaseObject::operator==(const std::string& objectName)
+{
+  return (this->objectName == objectName);
 }
 
Index: branches/std/src/lib/lang/base_object.h
===================================================================
--- branches/std/src/lib/lang/base_object.h	(revision 7216)
+++ branches/std/src/lib/lang/base_object.h	(revision 7218)
@@ -38,5 +38,5 @@
 
   /** @returns the className of the corresponding Object */
-  inline const char* getClassName() const { return this->className; };
+  inline const char* getClassName() const { return this->className.c_str(); };
   /** @returns the classID of the corresponding Object */
   inline int getClassID() const { return this->classID; };
@@ -44,8 +44,8 @@
 
   bool isA (ClassID classID) const;
-  bool isA (const char* className) const;
+  bool isA (const std::string& className) const;
   void whatIs() const;
 
-  bool operator==(const char* objectName);
+  bool operator==(const std::string& objectName);
   /** @param classID comparer for a ClassID @returns true on match, false otherwise */
   bool operator==(ClassID classID) { return this->isA(classID); };
@@ -55,8 +55,8 @@
 
  protected:
-  void setClassID(ClassID classID, const char* className);
+   void setClassID(ClassID classID, const std::string& className);
 
  private:
-    const char*        className;        //!< the name of the class
+    std::string        className;        //!< the name of the class
     long               classID;          //!< this is the id from the class_id.h enumeration
     std::string        objectName;       //!< The name of this object
Index: branches/std/src/lib/shell/shell_command.cc
===================================================================
--- branches/std/src/lib/shell/shell_command.cc	(revision 7216)
+++ branches/std/src/lib/shell/shell_command.cc	(revision 7218)
@@ -186,5 +186,5 @@
             {
 
-              (*alias)->getCommand()->executor->execute(objectList->front(), executionString.substr(inputSplits.getOffset(1), executionString.size())); /// TODO CHECK IF OK
+              (*alias)->getCommand()->executor->execute(objectList->front(), executionString.substr(inputSplits.getOffset(1))); /// TODO CHECK IF OK
             }
             else
@@ -243,5 +243,5 @@
               return false;
             if (inputSplits.getCount() > fktPos+1)
-              (*cmdIT)->executor->execute(objectPointer, executionString.substr(inputSplits.getOffset(fktPos +1), executionString.size())); /// TODO CHECK IF OK
+              (*cmdIT)->executor->execute(objectPointer, executionString.substr(inputSplits.getOffset(fktPos +1))); /// TODO CHECK IF OK
             else
               (*cmdIT)->executor->execute(objectPointer, "");
Index: branches/std/src/lib/util/executor/functor_list.h
===================================================================
--- branches/std/src/lib/util/executor/functor_list.h	(revision 7216)
+++ branches/std/src/lib/util/executor/functor_list.h	(revision 7218)
@@ -74,14 +74,8 @@
 //#define l_VECTOR_DEFAULT   Vector(0,0,0)        //!< Default value for a VECTOR
 
-#define l_CSTRING_TYPE     const char*          //!< The type of a CSTRING
-#define l_CSTRING_FUNC     isCString            //!< The function to parse a CSTRING
-#define l_CSTRING_NAME     "cstring"            //!< The name of a CSTRING
-#define l_CSTRING_PARAM    MT_STRING            //!< the type of the parameter CSTRING
-#define l_CSTRING_DEFAULT  ""                   //!< a default Value for an CSTRING
-
 #define l_STRING_TYPE      const std::string&   //!< The type of a STRING
 #define l_STRING_FUNC      isString             //!< The function to parse a STRING
 #define l_STRING_NAME      "string"             //!< The name of a STRING
-#define l_STRING_PARAM     MT_CSTRING           //!< the type of the parameter STRING
+#define l_STRING_PARAM     MT_STRING           //!< the type of the parameter STRING
 #define l_STRING_DEFAULT   ""                   //!< a default Value for an STRING
 
Index: branches/std/src/lib/util/loading/resource_manager.cc
===================================================================
--- branches/std/src/lib/util/loading/resource_manager.cc	(revision 7216)
+++ branches/std/src/lib/util/loading/resource_manager.cc	(revision 7218)
@@ -849,5 +849,5 @@
   {
     std::string homeDir;
-    std::string newName = name.substr(1, name.size()-1);
+    std::string newName = name.substr(1);
 #ifdef __WIN32__
     homeDir = getenv("USERPROFILE");
Index: branches/std/src/lib/util/multi_type.cc
===================================================================
--- branches/std/src/lib/util/multi_type.cc	(revision 7216)
+++ branches/std/src/lib/util/multi_type.cc	(revision 7218)
@@ -55,5 +55,4 @@
       break;
     case MT_STRING:
-    case MT_CSTRING:
       this->storedString = "";
       break;
Index: branches/std/src/lib/util/multi_type.h
===================================================================
--- branches/std/src/lib/util/multi_type.h	(revision 7216)
+++ branches/std/src/lib/util/multi_type.h	(revision 7218)
@@ -24,6 +24,4 @@
   MT_EXT1            = 32,                 //!< An external Type.
   MT_EXT2            = 64,                 //!< An external Type.
-
-  MT_CSTRING         = 128,                //!< An entire String.
 } MT_Type;
 