Index: /branches/std/src/orxonox.h
===================================================================
--- /branches/std/src/orxonox.h	(revision 7219)
+++ /branches/std/src/orxonox.h	(revision 7220)
@@ -32,5 +32,5 @@
   Orxonox ();
 
-  void parseIniFile(const char* fileName);
+  void parseIniFile(const std::string& fileName);
 
   int initResources ();
Index: /branches/std/src/util/track/track_manager.cc
===================================================================
--- /branches/std/src/util/track/track_manager.cc	(revision 7219)
+++ /branches/std/src/util/track/track_manager.cc	(revision 7220)
@@ -123,5 +123,5 @@
  * @returns The TrackElement if Found, NULL otherwise.
 */
-TrackElement* TrackElement::findByName(const char* trackName)
+TrackElement* TrackElement::findByName(const std::string& trackName)
 {
   // return if Found.
@@ -532,5 +532,5 @@
  * @param trackName the Name of the Track to work on
 */
-void TrackManager::workOnS(const char* trackName)
+void TrackManager::workOnS(const std::string& trackName)
 {
   TrackElement* tmpElem = this->firstTrackElem->findByName(trackName);
@@ -657,5 +657,5 @@
    @todo this must be better
 */
-void TrackManager::setSavePointS(const char* nextElementName)
+void TrackManager::setSavePointS(const std::string& nextElementName)
 {
   this->setSavePoint(NULL);
@@ -725,5 +725,5 @@
   for(int i = 0; i < count; i++)
     {
-      this->firstTrackElem->findByID(trackIDs[i])->setName(va_arg(name, const char*));
+      this->firstTrackElem->findByID(trackIDs[i])->setName(va_arg(name, const std::string&));
     }
   va_end(name);
@@ -734,5 +734,5 @@
    \see TrackManager::fork(unsigned int count, ...)
 */
-void TrackManager::forkS(const char* forkString)
+void TrackManager::forkS(const std::string& forkString)
 {
   SubString strings(forkString, ',');
@@ -860,5 +860,5 @@
   for(int i = 0; i < count; i++)
     {
-      const char* name = va_arg (NAME, char*);
+      const std::string& name = va_arg (NAME, char*);
       TrackElement* tmpElem = this->firstTrackElem->findByName(name);
       if (tmpElem)
@@ -875,5 +875,5 @@
    \see void TrackManager::join(unsigned int count, ...)
 */
-void TrackManager::joinS(const char* joinString)
+void TrackManager::joinS(const std::string& joinString)
 {
   SubString strings(joinString, ',');
Index: /branches/std/src/util/track/track_manager.h
===================================================================
--- /branches/std/src/util/track/track_manager.h	(revision 7219)
+++ /branches/std/src/util/track/track_manager.h	(revision 7220)
@@ -46,5 +46,5 @@
 
   TrackElement* findByID(unsigned int trackID);
-  TrackElement* findByName(const char* trackName);
+  TrackElement* findByName(const std::string& trackName);
   bool backLoopCheck() const;
 
@@ -153,5 +153,5 @@
   void addHotPoint(float x, float y, float z);
   int addHotPointV(Vector newPoint, TrackElement* trackElem = NULL);
-  void setSavePointS(const char* nextElementName);
+  void setSavePointS(const std::string& nextElementName);
   void setSavePoint(TrackElement* trackElem = NULL);
   void fork(unsigned int count, ...);
@@ -162,5 +162,5 @@
   void condition(CONDITION cond, void* subject, TrackElement* trackElem = NULL);
   void join(unsigned int count, ...);
-  void joinS(const char* joinString);
+  void joinS(const std::string& joinString);
   void joinS(unsigned int cound, ...);
   void joinV(unsigned int count, int* trackIDs);
Index: /branches/std/src/world_entities/creatures/md2_creature.cc
===================================================================
--- /branches/std/src/world_entities/creatures/md2_creature.cc	(revision 7219)
+++ /branches/std/src/world_entities/creatures/md2_creature.cc	(revision 7220)
@@ -52,5 +52,5 @@
  * @param fileName the name of the File to load the MD2Creature from (absolute path)
  */
-MD2Creature::MD2Creature(const char* fileName)
+MD2Creature::MD2Creature(const std::string& fileName)
 {
   this->init();
@@ -59,5 +59,5 @@
   if(!doc.LoadFile())
   {
-    PRINTF(2)("Loading file %s failed for md2 creature.\n", fileName);
+    PRINTF(2)("Loading file %s failed for md2 creature.\n", fileName.c_str());
     return;
   }
Index: /branches/std/src/world_entities/creatures/md2_creature.h
===================================================================
--- /branches/std/src/world_entities/creatures/md2_creature.h	(revision 7219)
+++ /branches/std/src/world_entities/creatures/md2_creature.h	(revision 7220)
@@ -19,5 +19,5 @@
   public:
 
-    MD2Creature(const char* fileName);
+    MD2Creature(const std::string& fileName);
     MD2Creature(const TiXmlElement* root = NULL);
     virtual ~MD2Creature();
Index: /branches/std/src/world_entities/space_ships/helicopter.cc
===================================================================
--- /branches/std/src/world_entities/space_ships/helicopter.cc	(revision 7219)
+++ /branches/std/src/world_entities/space_ships/helicopter.cc	(revision 7220)
@@ -55,5 +55,5 @@
  * @param fileName the name of the File to load the helicopter from (absolute path)
  */
-Helicopter::Helicopter(const char* fileName)
+Helicopter::Helicopter(const std::string& fileName)
 {
   this->init();
@@ -62,5 +62,5 @@
   if(!doc.LoadFile())
   {
-    PRINTF(2)("Loading file %s failed for Helicopter.\n", fileName);
+    PRINTF(2)("Loading file %s failed for Helicopter.\n", fileName.c_str());
     return;
   }
Index: /branches/std/src/world_entities/space_ships/helicopter.h
===================================================================
--- /branches/std/src/world_entities/space_ships/helicopter.h	(revision 7219)
+++ /branches/std/src/world_entities/space_ships/helicopter.h	(revision 7220)
@@ -17,5 +17,5 @@
 
     Helicopter();
-    Helicopter(const char* fileName);
+    Helicopter(const std::string& fileName);
     Helicopter(const TiXmlElement* root);
     virtual ~Helicopter();
Index: /branches/std/src/world_entities/space_ships/hover.cc
===================================================================
--- /branches/std/src/world_entities/space_ships/hover.cc	(revision 7219)
+++ /branches/std/src/world_entities/space_ships/hover.cc	(revision 7220)
@@ -47,5 +47,5 @@
  * @param fileName the name of the File to load the hover from (absolute path)
  */
-Hover::Hover(const char* fileName)
+Hover::Hover(const std::string& fileName)
 {
   this->init();
@@ -54,5 +54,5 @@
   if(!doc.LoadFile())
   {
-    PRINTF(2)("Loading file %s failed for Hover.\n", fileName);
+    PRINTF(2)("Loading file %s failed for Hover.\n", fileName.c_str());
     return;
   }
Index: /branches/std/src/world_entities/space_ships/hover.h
===================================================================
--- /branches/std/src/world_entities/space_ships/hover.h	(revision 7219)
+++ /branches/std/src/world_entities/space_ships/hover.h	(revision 7220)
@@ -14,5 +14,5 @@
   public:
 
-    Hover(const char* fileName);
+    Hover(const std::string& fileName);
     Hover(const TiXmlElement* root = NULL);
     virtual ~Hover();
Index: /branches/std/src/world_entities/space_ships/space_ship.cc
===================================================================
--- /branches/std/src/world_entities/space_ships/space_ship.cc	(revision 7219)
+++ /branches/std/src/world_entities/space_ships/space_ship.cc	(revision 7220)
@@ -69,5 +69,5 @@
  * @param fileName the name of the File to load the spaceship from (absolute path)
  */
-SpaceShip::SpaceShip(const char* fileName)
+SpaceShip::SpaceShip(const std::string& fileName)
 {
   this->init();
@@ -76,5 +76,5 @@
   if(!doc.LoadFile())
   {
-    PRINTF(2)("Loading file %s failed for spaceship.\n", fileName);
+    PRINTF(2)("Loading file %s failed for spaceship.\n", fileName.c_str());
     return;
   }
Index: /branches/std/src/world_entities/space_ships/space_ship.h
===================================================================
--- /branches/std/src/world_entities/space_ships/space_ship.h	(revision 7219)
+++ /branches/std/src/world_entities/space_ships/space_ship.h	(revision 7220)
@@ -21,5 +21,5 @@
 
   public:
-    SpaceShip(const char* fileName);
+    SpaceShip(const std::string& fileName);
     SpaceShip(const TiXmlElement* root = NULL);
     virtual ~SpaceShip();
Index: /branches/std/src/world_entities/space_ships/turbine_hover.cc
===================================================================
--- /branches/std/src/world_entities/space_ships/turbine_hover.cc	(revision 7219)
+++ /branches/std/src/world_entities/space_ships/turbine_hover.cc	(revision 7220)
@@ -49,5 +49,5 @@
  * @param fileName the name of the File to load the turbine_hover from (absolute path)
  */
-TurbineHover::TurbineHover(const char* fileName)
+TurbineHover::TurbineHover(const std::string& fileName)
 {
   this->init();
@@ -56,5 +56,5 @@
   if(!doc.LoadFile())
   {
-    PRINTF(2)("Loading file %s failed for TurbineHover.\n", fileName);
+    PRINTF(2)("Loading file %s failed for TurbineHover.\n", fileName.c_str());
     return;
   }
Index: /branches/std/src/world_entities/space_ships/turbine_hover.h
===================================================================
--- /branches/std/src/world_entities/space_ships/turbine_hover.h	(revision 7219)
+++ /branches/std/src/world_entities/space_ships/turbine_hover.h	(revision 7220)
@@ -18,5 +18,5 @@
   public:
 
-    TurbineHover(const char* fileName);
+    TurbineHover(const std::string& fileName);
     TurbineHover(const TiXmlElement* root = NULL);
     virtual ~TurbineHover();
Index: /branches/std/src/world_entities/terrain.cc
===================================================================
--- /branches/std/src/world_entities/terrain.cc	(revision 7219)
+++ /branches/std/src/world_entities/terrain.cc	(revision 7220)
@@ -59,9 +59,9 @@
    this either loads out of an OBJ-file, or loads a heightmap if no .obj-extension is found.
 */
-Terrain::Terrain(const char* fileName)
+Terrain::Terrain(const std::string& fileName)
 {
   this->init();
 
-  if (!strstr(fileName, ".obj") || !strstr(fileName, ".OBJ") )
+  if (fileName.rfind(".obj" ) != -1 || fileName.rfind(".OBJ") != -1 )
   {
     this->loadModel(fileName);
Index: /branches/std/src/world_entities/terrain.h
===================================================================
--- /branches/std/src/world_entities/terrain.h	(revision 7219)
+++ /branches/std/src/world_entities/terrain.h	(revision 7220)
@@ -29,5 +29,5 @@
  public:
   Terrain(const TiXmlElement* root = NULL);
-  Terrain(const char* fileName);
+  Terrain(const std::string& fileName);
   Terrain(DebugTerrain debugTerrain);
   virtual ~Terrain();