Index: data/trunk/AUTHORS
===================================================================
--- data/trunk/AUTHORS	(revision 7217)
+++ data/trunk/AUTHORS	(revision 7223)
@@ -351,6 +351,6 @@
 materials/textures/LightningBall_7.tga                      Joël Smely
 materials/textures/LightningBall_8.tga                      Joël Smely
-materials/textures/Lightning_gun4.tga                       jsmely*
-materials/textures/Lightning_gun_pic2.tga                   jsmely*
+materials/textures/Lightning_gun4.tga                       Joël Smely
+materials/textures/Lightning_gun_pic2.tga                   Joël Smely
 materials/textures/LightningGun.tga                         Joël Smely
 materials/textures/mapgrid.tga                              Si Sun
@@ -388,5 +388,5 @@
 materials/textures/sample_loading.jpg                       unknown
 materials/textures/Sepia1D.tga                              Fabian Landau?
-materials/textures/sewer_001.png                            polakma*?
+materials/textures/sewer_001.png                            Martin Polak?
 materials/textures/shield.tga                               Eric Beier and Benedict Simlinger
 materials/textures/skypanoramagen1_bk.jpg                   Fabian Landau?
@@ -454,40 +454,40 @@
 materials/textures/wall01.jpg                               Felix Schulthess
 materials/textures/white.tga                                Felix Schulthess
-materials/textures/sl_metal/sl_metal_001.png                polakma*?
-materials/textures/sl_metal/sl_metal_002.png                polakma*?
-materials/textures/sl_metal/sl_metal_003.png                polakma*?
-materials/textures/sl_metal/sl_metal_004.png                polakma*?
-materials/textures/sl_metal/sl_metal_005.png                polakma*?
-materials/textures/sl_metal/sl_metal_006.png                polakma*?
-materials/textures/sl_metal/sl_metal_007.png                polakma*?
-materials/textures/sl_metal/sl_metal_008.png                polakma*?
-materials/textures/sl_metal/sl_metal_009.png                polakma*?
-materials/textures/sl_metal/sl_metal_010.png                polakma*?
-materials/textures/sl_metal/sl_metal_011.png                polakma*?
-materials/textures/sl_metal/sl_metal_012.png                polakma*?
-materials/textures/sl_metal/sl_metal_013.png                polakma*?
-materials/textures/sl_metal/sl_metal_014.png                polakma*?
-materials/textures/sl_metal/sl_metal_015.png                polakma*?
-materials/textures/sl_metal/sl_metal_016.png                polakma*?
-materials/textures/sl_metal/sl_metal_017.png                polakma*?
-materials/textures/sl_metal/sl_metal_018.png                polakma*?
-materials/textures/sl_metal/sl_metal_019.png                polakma*?
-materials/textures/sl_metal/sl_metal_020.png                polakma*?
-materials/textures/sl_metal/sl_metal_021.png                polakma*?
-materials/textures/sl_metal/sl_metal_022.png                polakma*?
-materials/textures/sl_metal/sl_metal_023.png                polakma*?
-materials/textures/sl_metal/sl_metal_024.png                polakma*?
-materials/textures/sl_metal/sl_metal_025.png                polakma*?
-materials/textures/sl_metal/sl_metal_026.png                polakma*?
-materials/textures/sl_metal/sl_metal_027.png                polakma*?
-materials/textures/sl_metal/sl_metal_028.png                polakma*?
-materials/textures/sl_metal/sl_metal_029.png                polakma*?
-materials/textures/sl_metal/sl_metal_030.png                polakma*?
-materials/textures/sl_metal/sl_metal_031.png                polakma*?
-materials/textures/sl_metal/sl_metal_032.png                polakma*?
-materials/textures/sl_metal/sl_metal_034.png                polakma*?
-materials/textures/sl_metal/sl_metal_035.png                polakma*?
-materials/textures/sl_metal/sl_metal_036.png                polakma*?
-materials/textures/sl_metal/sl_metal_037.png                polakma*?
+materials/textures/sl_metal/sl_metal_001.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_002.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_003.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_004.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_005.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_006.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_007.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_008.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_009.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_010.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_011.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_012.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_013.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_014.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_015.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_016.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_017.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_018.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_019.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_020.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_021.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_022.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_023.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_024.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_025.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_026.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_027.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_028.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_029.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_030.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_031.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_032.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_034.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_035.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_036.png                Martin Polak?
+materials/textures/sl_metal/sl_metal_037.png                Martin Polak?
 models/assff_lod_med.mesh                                   Oliver Scheuss
 models/assff.mesh                                           Felix Schulthess